// ================================= ġ  α׷ =======================
//      : TSC2003
// ----------------------------------------------------------------------------
// Լ 
int Touch_Data(int scan_time);						// ġ  
void TSC2003_Setup(void);						// I2c ʱȭ TSC2003ʱȭ
void TSC2003_Write(unsigned char byte);					// TSC2003 ġ Write
unsigned TSC2003_Word_Read(unsigned char cmd);				// TSC2003 ġ Word Read

//  
int Touch_X = 0,Touch_Y = 0;						// ġ ġ  

// ========================== ġκ ͸  =======================
// [μ] int scan_time
// Item1: ġ SCAN Timne(scan_time * 10ms)
// [] 1( ȿ),0( )
// [] Touch_X,Touch_Y : ġ  
//        _screen_mode :  ȭ 
// ---------------------------------------------------------------------------
int Touch_Data(int scan_time)
{
int x,y;

	if((PINE&0x80) == 0){						// ġ ?
		if(timer0_touch_cnt >= scan_time){			// ġ  üũ Ÿ scan_time*10ms
			x = TSC2003_Word_Read(0xcc);			// X  / 12bit / ADC ON
			y = TSC2003_Word_Read(0xdc);			// Y  / 12bit / ADC ON
			TSC2003_Write(0x38);				// PENIRQ ready mode
			if(_screen_mode == _SCREEN_COLUMN_SET){		// ι 
				Touch_X = 4095 - y;			// ġ 12bit a/d
				Touch_Y = 4095 - x;			// ġ 12bit a/d
			}
			else{						// ι 
				Touch_X = x;				// ǥ ٲ
				Touch_Y = 4095 - y;			// ġ 12bit a/d
			}
			timer0_touch_cnt = 0;				// timer clear
			return(1);
		}
	}
	else timer0_touch_cnt = 0;					//  
	return(0);
}

// ================================ TSC2003 Setup ============================
// [μ] void
// ---------------------------------------------------------------------------
void TSC2003_Setup(void)
{
// TWI(I2c) setup
	TWBR = 0x0c;							// Bit Rate: 400.000 kHz
	TWDR = 0xff;							// TWI DATA = 0xff
	TWSR = 0x00;							//  Clear , prescaler = 00(1)

// TSC2003 setup
	TSC2003_Write(0x38);						// PENIRQ ready mode
}

// ================================ TSC2003 Write ============================
// [μ] unsigned char datau
// Item1:  
// ---------------------------------------------------------------------------
void TSC2003_Write(unsigned char datau)
{
	TWCR = 0xa4;							// START
	while(((TWCR & 0x80) == 0x00) || ((TWSR & 0xf8) != 0x08));	
	TWDR = 0x90;							// Address 0 + write
	TWCR = 0x84;							// TWINT 1 Ἥ Ŭ
	while(((TWCR & 0x80) == 0x00) || ((TWSR & 0xf8) != 0x18));	
	TWDR = datau;							// data ۽
	TWCR = 0x84;							// TWINT 1 Ἥ Ŭ
	while(((TWCR & 0x80) == 0x00) || ((TWSR & 0xf8) != 0x28));

	TWCR = 0x94;							// Ϸ 
}

// =============================== TSC2003 word Read =========================
// [μ] unsigned char cmd
// Item1: ġ  command 
// ---------------------------------------------------------------------------
unsigned TSC2003_Word_Read(unsigned char cmd)
{
unsigned char byte;
unsigned rdatau = 0;

	TWCR = 0xa4;							// START
	while(((TWCR & 0x80) == 0x00) || ((TWSR & 0xf8) != 0x08));	
	TWDR = 0x90;							// Address 0 + write
	TWCR = 0x84;							// TWINT 1 Ἥ Ŭ
	while(((TWCR & 0x80) == 0x00) || ((TWSR & 0xf8) != 0x18));	
	TWDR = cmd;							// cmd data ۽
	TWCR = 0x84;							// TWINT 1 Ἥ Ŭ
	while(((TWCR & 0x80) == 0x00) || ((TWSR & 0xf8) != 0x28));
  
	TWCR = 0xa4;							// START
	while(((TWCR & 0x80) == 0x00) || ((TWSR & 0xf8) != 0x10));	//  ?
	TWDR = 0x91;   							// Address 0 + read   
	TWCR = 0x84;							// TWINT 1 Ἥ Ŭ    
	while(((TWCR & 0x80) == 0x00) || ((TWSR & 0xf8) != 0x40));	// SLA-R Ϸ?
	TWCR = 0xc4;							// data read
	while(((TWCR & 0x80) == 0x00) || ((TWSR & 0xf8) != 0x50));	// data  ACK?
	rdatau = TWDR;
	TWCR = 0x84;							// TWINT 1 Ἥ Ŭ    
	while(((TWCR & 0x80) == 0x00) || ((TWSR & 0xf8) != 0x58));	// data  ACK?
	byte = TWDR;

	TWCR = 0x94;							// Ϸ           	

	rdatau =  (rdatau << 4) & 0x0ff0;				// D11-D4
	rdatau |= (unsigned)((byte >> 4) & 0x0f);			// D3-D0	

	return rdatau;
}
